package main

import (
	"encoding/json"
	"fmt"
	"github.com/stripe/stripe-go"
	"github.com/stripe/stripe-go/charge"
	"github.com/stripe/stripe-go/customer"
	"github.com/stripe/stripe-go/paymentintent"
	"gitlab.okta-solutions.com/mashroom/backend/cardpayment/impl"
	"io/ioutil"
	"net/http"
	"strings"
)

const (
	STRIPE_KEY = "sk_test_fwK7y4sYjzWGwuzNEg3aDv2y"
)

func main() {
	//http.HandleFunc("/webhooks", HandleWebhooks)               // установим роутер
	//http.HandleFunc("/webhooks-charge", HandleWebhooksCharge)  // установим роутер
	//http.HandleFunc("/webhooks-source", HandleWebhooksSource)  // установим роутер
	//http.HandleFunc("/test-cardpayment", HandlePaymentByToken) // установим роутер
	//http.HandleFunc("/test-source", HandlePaymentBySource)     // установим роутер
	//http.HandleFunc("/test-sepa", HandleSepaPayment)           // установим роутер
	//err := http.ListenAndServe(":9000", nil)                   // задаем слушать порт
	//if err != nil {
	//	log.Fatal("ListenAndServe: ", err)
	//}

	GetPaymentData("pi_1DtBm9GzknheRHmRmBVviDox")
}

func HandleWebhooks(w http.ResponseWriter, r *http.Request) {
	fmt.Println()
	fmt.Println("WEBHOOK ALL!!!")

	resp_body, err := ioutil.ReadAll(r.Body)
	if err != nil {
		fmt.Fprintf(w, err.Error())
		return
	}

	bytes := []byte(resp_body)

	var stripeCallback impl.StripeCallback
	err = json.Unmarshal(bytes, &stripeCallback)
	if err != nil {
		fmt.Fprintf(w, err.Error())
		return
	}

	fmt.Println(stripeCallback.Type)

	if strings.HasPrefix(stripeCallback.Type, "charge") {
		var stripeCharge impl.StripeCharge
		err = json.Unmarshal(bytes, &stripeCharge)
		if err != nil {
			fmt.Fprintf(w, err.Error())
			return
		}

		fmt.Println(stripeCharge)

		// fmt.Println(stripeCharge.ID)
		// fmt.Println(stripeCharge.Data.Object.ID)
		// fmt.Println(stripeCharge.Data.Object.Status)
		// fmt.Println(stripeCharge.Data.Object.FailureCode)
		// fmt.Println(stripeCharge.Data.Object.Created)
		// fmt.Println(stripeCharge.Data.Object.BalanceTransaction)
		// fmt.Println(stripeCharge.Data.Object.Description)
		// fmt.Println(stripeCharge.Data.Object.Refunds.URL)
		// fmt.Println(stripeCharge.Data.Object.Source.ID)

	} else if strings.HasPrefix(stripeCallback.Type, "source") {
		var stripeSource impl.StripeSource
		err = json.Unmarshal(bytes, &stripeSource)
		if err != nil {
			fmt.Fprintf(w, err.Error())
			return
		}

		// fmt.Println(stripeSource)
	} else {
		// fmt.Println(stripeCallback.Type)
	}

	fmt.Println()

	fmt.Fprintf(w, "{status:\"200\"}")
}

func HandleWebhooksCharge(w http.ResponseWriter, r *http.Request) {
	fmt.Println()
	fmt.Println("WEBHOOK CHARGE!!!")
	r.ParseForm()       // анализ аргументов,
	fmt.Println(r.Body) // ввод информации о форме на стороне сервера

	resp_body, err := ioutil.ReadAll(r.Body)
	if err != nil {
		fmt.Fprintf(w, err.Error())
		return
	}

	var data impl.StripeCharge
	err = json.Unmarshal([]byte(resp_body), &data)
	fmt.Println(data.ID)
	fmt.Println(data.Type)
	fmt.Println(data.Data.Object.ID)
	fmt.Println(data.Data.Object.Status)
	fmt.Println(data.Data.Object.Paid)
	fmt.Println(data)

	fmt.Println()
	for k, v := range r.Form {
		fmt.Println("key:", k)
		fmt.Println("val:", strings.Join(v, ""))
	}

	fmt.Fprintf(w, "{status:\"200\"}")
}

func HandleWebhooksSource(w http.ResponseWriter, r *http.Request) {
	fmt.Println()
	fmt.Println("WEBHOOK SOURCE!!!")
	r.ParseForm()       // анализ аргументов,
	fmt.Println(r.Body) // ввод информации о форме на стороне сервера

	resp_body, err := ioutil.ReadAll(r.Body)
	if err != nil {
		fmt.Fprintf(w, err.Error())
		return
	}

	var data impl.StripeCharge
	err = json.Unmarshal([]byte(resp_body), &data)

	fmt.Println(data.Type)
	fmt.Println(data.ID)
	fmt.Println(data.Object)
	fmt.Println(data.Data.Object.Status)
	fmt.Println(data.Data.Object.ID)

	fmt.Println(data.Type)
	fmt.Println()

	for k, v := range r.Form {
		fmt.Println("key:", k)
		fmt.Println("val:", strings.Join(v, ""))
	}

	fmt.Fprintf(w, "{status:\"200\"}")
}

func HandlePaymentByToken(w http.ResponseWriter, r *http.Request) {
	r.ParseForm()       // анализ аргументов,
	fmt.Println(r.Form) // ввод информации о форме на стороне сервера
	fmt.Println("path", r.URL.Path)
	fmt.Println("scheme", r.URL.Scheme)
	fmt.Println(r.Form["url_long"])
	for k, v := range r.Form {
		fmt.Println("key:", k)
		fmt.Println("val:", strings.Join(v, ""))
	}

	stripe.Key = STRIPE_KEY

	token := r.FormValue("stripeToken")

	msg, err := PaymentByToken(token, 999, "test payment")
	if err != nil {
		fmt.Fprintf(w, err.Error())
	} else {
		fmt.Fprintf(w, msg)
	}
}

func PaymentByToken(token string, amount int64, description string) (string, error) {
	stripe.Key = STRIPE_KEY

	chargeParams := &stripe.ChargeParams{
		Amount:      stripe.Int64(amount),
		Currency:    stripe.String(string(stripe.CurrencyGBP)),
		Description: stripe.String(description),
	}

	chargeParams.SetSource(token)
	ch, err := charge.New(chargeParams)
	msg := fmt.Sprintf("paid:%v status: %s error: %s  message: %s ", ch.Paid, ch.Status, ch.FailureCode, ch.FailureMessage)
	if err != nil {
		stripeErr := err.(*stripe.Error)
		errStr := fmt.Sprintf("http error code: %d, error code: %s, error message: %s", stripeErr.HTTPStatusCode, stripeErr.Code, stripeErr.Msg)
		return errStr, err
	} else {
		return msg, nil
	}
}

func HandlePaymentBySource(w http.ResponseWriter, r *http.Request) {
	r.ParseForm()       // анализ аргументов,
	fmt.Println(r.Form) // ввод информации о форме на стороне сервера
	fmt.Println("path", r.URL.Path)
	for k, v := range r.Form {
		fmt.Println("key:", k)
		fmt.Println("val:", strings.Join(v, ""))
	}

	stripe.Key = STRIPE_KEY

	stripeSource := r.FormValue("stripeSource")

	msg, err := PaymentBySource(stripeSource, 999, "test payment", "qqqrqewr@wewer.uk")
	if err != nil {
		fmt.Fprintf(w, err.Error())
	} else {
		fmt.Fprintf(w, msg)
	}
}

func HandleSepaPayment(w http.ResponseWriter, r *http.Request) {
	r.ParseForm()       // анализ аргументов,
	fmt.Println(r.Form) // ввод информации о форме на стороне сервера
	// fmt.Println("path", r.URL.Path)
	for k, v := range r.Form {
		fmt.Println("key:", k)
		fmt.Println("val:", strings.Join(v, ""))
	}

	fmt.Println("SEPA!!!")
	stripeSource := r.FormValue("stripeSource")
	email := r.FormValue("email")
	err := SepaPayment(stripeSource, 687, "john doe", email)
	if err != nil {
		fmt.Println(err)
	}
}

func SepaPayment(stripeSource string, amount int64, name string, email string) error {
	stripe.Key = STRIPE_KEY

	customerParams := &stripe.CustomerParams{
		Email: stripe.String(email),
	}
	err := customerParams.SetSource(stripeSource)
	if err != nil {
		return err
	}

	c, err := customer.New(customerParams)
	if err != nil {
		return err
	}

	chargeParams := &stripe.ChargeParams{
		Amount:   stripe.Int64(amount),
		Currency: stripe.String(string(stripe.CurrencyEUR)),
		Customer: stripe.String(c.ID),
	}
	err = chargeParams.SetSource(stripeSource)
	if err != nil {
		return err
	}

	ch, err := charge.New(chargeParams)
	if err != nil {
		return err
	}

	fmt.Println(ch.ID)
	fmt.Println(ch.Status)

	return nil
}

func PaymentBySource(stripeSource string, amount int64, description string, email string) (string, error) {
	stripe.Key = STRIPE_KEY

	customerParams := &stripe.CustomerParams{
		Email: stripe.String(email),
	}
	err := customerParams.SetSource(stripeSource)
	if err != nil {
		return err.Error(), err
	}

	c, err := customer.New(customerParams)
	if err != nil {
		return err.Error(), err
	}

	fmt.Println(fmt.Sprintf("customer: %v", c))

	chargeParams := &stripe.ChargeParams{
		Amount:      stripe.Int64(amount),
		Currency:    stripe.String(string(stripe.CurrencyGBP)),
		Description: stripe.String(description),
		Customer:    stripe.String(c.ID),
	}

	err = chargeParams.SetSource(stripeSource)
	if err != nil {
		return err.Error(), err
	}

	ch, err := charge.New(chargeParams)

	msg := fmt.Sprintf("paid:%v status: %s error: %s  message: %s ", ch.Paid, ch.Status, ch.FailureCode, ch.FailureMessage)
	if err != nil {
		stripeErr := err.(*stripe.Error)
		errStr := fmt.Sprintf("http error code: %d, error code: %s, error message: %s", stripeErr.HTTPStatusCode, stripeErr.Code, stripeErr.Msg)
		return errStr, err
	} else {
		return msg, nil
	}
}

func CreatePaymentIntent(amount int64, currency string) (*string, error) {
	stripe.Key = STRIPE_KEY

	params := &stripe.PaymentIntentParams{
		Amount:   stripe.Int64(1099),
		Currency: stripe.String(string(stripe.CurrencyGBP)),
		PaymentMethodTypes: []*string{
			stripe.String("card"),
		},
	}
	p, err := paymentintent.New(params)
	if err != nil {
		return nil, err
	}

	fmt.Println(fmt.Sprintf("paymentintent: %v", p))

	return &p.ClientSecret, nil
}

func GetPaymentData(id string) {
	stripe.Key = STRIPE_KEY

	prm := &stripe.PaymentIntentParams{}

	p, err := paymentintent.Get(id, prm)
	if err != nil {
		fmt.Println(err)
	}
	fmt.Println(p.Charges.Data[0])

}
